Index: Configuration.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Configuration.cpp,v
retrieving revision 1.38
retrieving revision 1.57
diff -u -p -b -r1.38 -r1.57
--- Configuration.cpp	10 Jul 2004 14:14:45 -0000	1.38
+++ Configuration.cpp	23 Jan 2005 00:23:45 -0000	1.57
@@ -1,3 +1,13 @@
+/////////////////////////////////////////////////////////////////////
+//  $Id: Configuration.cpp,v 1.57 2005/01/23 00:23:45 klas Exp $
+//
+//  Usage: Functions and stuff for Configure class, holding and
+//           reading config stuff.
+//
+//  A part of babyftpd, licensed under the GNU GPL, see the file 
+//    LICENSE for complete information.                                         
+/////////////////////////////////////////////////////////////////////
+
 #define __CONFIGURATION_CPP__
 
 #include "Configuration.h"
@@ -12,26 +22,31 @@ Configuration::Configuration()
   general.port = 21; // default port
   general.default_type = 0;
   general.verbose = 1;
-  general.log_level = 5;
-  general.xferlog = 1; // log all transfers or not?
-  general.xferlog_file = "/var/log/xferlog"; // where transfer logs go
   general.no_daemon = false; // daemon mode or not?
   general.os = "UNIX"; // what OS is this?
   general.admin_email = ""; // admin email?
-  char *tmp = new char[20];
+  general.lifebeat_tick = 300; // run the lifebeat() function every this
+  char tmp[20];
   gethostname(tmp, 20);
   general.welcome_msg = "BabyFTPd ";
   general.welcome_msg += VERSION;
   general.welcome_msg += " Server [";
   general.welcome_msg += tmp;
   general.welcome_msg += "]";
-  delete[] tmp;
 #ifdef USE_TLS
   general.tls_key = "/root/tls_key.pem";
   general.tls_cert = "/root/tls_cert.pem";
   general.tls_ca = "/root/tls_ca.pem";
   general.tls_crl = "/root/tls_crl.pem";
+  general.dh_regenerate = 3600; // seconds between diffie-hellman regenerations
+  general.user = 0; // by default when run all as root
+
+  general_user.encryption = ALLOW;
 #endif	
+  logger.log_level = 3; // 3 is probably a sensible default?
+  logger.xferlog = true; // by default all transfers are logged
+  logger.xferlog_file = "/var/log/xferlog"; // here
+  logger.thread_id = false; // we don't want thread ids all over the logs
   
   // these options end up as default for all users, that is, those that don't occur in the conf file get these values
   general_user.id = "user_general";
@@ -45,51 +60,43 @@ Configuration::Configuration()
 
 Configuration::~Configuration()
 {
-  if(parsed)
-    delete[] users; 
 }
 
 bool Configuration::parse_config_file()
 {
-  int rows = file_rows(conf_file);
-  string Sgeneral, Suser, user_names;
+  vector<string> file_buff;
+  fill_buff(file_buff, conf_file);
   
-  string *file_buff = new string[rows];
-  fill_buff(file_buff, conf_file, rows);
+  string Sgeneral = get_variables(file_buff, "general", 1);
+  set_general(Sgeneral);
   
-  get_variables(file_buff, rows, Sgeneral, "general");
-  set_general(general, Sgeneral);
+  string Suser = get_variables(file_buff, "general", 2);
+  general_user = set_users(Suser);
   
-  get_variables(file_buff, rows, Suser, "general", 2);
-  set_users(general_user, Suser);
+  string Slog = get_variables(file_buff, "log", 1);
+  set_logger(Slog);
 
-  num_users = count_users(file_buff, rows, user_names) - 1; // first user is 0.
+  string user_names;
+  num_users = count_users(file_buff, user_names) - 1; // first user is 0.
   
   class StringTokenizer *names = new StringTokenizer(user_names, ",", false);
   names->nextToken(); // not nice, but nicer.
   
-  users = new struct users_stru[num_users]; 
-  parsed = true;
+  users.reserve(num_users + 1);
   for(int i = 0; i < num_users; i++)
   {
-    string Susers;
-    get_variables(file_buff, rows, Susers, names->nextToken().c_str(), 2);
-    set_users(users[i], Susers);
+    string Susers = get_variables(file_buff, names->nextToken().c_str(), 2);
+    users.push_back(set_users(Susers));
   }
 
+  parsed = true;
   delete names;
-  delete[] file_buff;
   return true;
 }
 
-void Configuration::set_users(struct users_stru &usr, string &variables)
+struct users_stru Configuration::set_users(string variables)
 {
-  usr.sim_data = general_user.sim_data;
-  usr.idle = general_user.idle;
-  usr.noftp = general_user.noftp;
-  usr.only_home = general_user.only_home;
-  usr.only_passive = general_user.only_passive;
-  usr.user_limit = general_user.user_limit;
+  struct users_stru usr = general_user;
   
   class StringTokenizer *var = new StringTokenizer(variables, "\n", false);
   usr.id = var->nextToken();
@@ -100,56 +107,86 @@ void Configuration::set_users(struct use
     class StringTokenizer *st = new StringTokenizer(str, " ", false);
     string op = st->nextToken();
     string arg = st->nextToken();
-    if(op.compare(users_op[0]) == 0)
+    if(op == users_op[0])
       usr.sim_data = atoi(arg.c_str());
-    else if(op.compare(users_op[1]) == 0)
+    else if(op == users_op[1])
       usr.idle = atoi(arg.c_str());
-    else if(op.compare(users_op[2]) == 0)
+    else if(op == users_op[2])
       usr.noftp = atoi(arg.c_str());
-    else if(op.compare(users_op[3]) == 0)
+    else if(op == users_op[3])
       usr.only_home = atoi(arg.c_str());
-    else if(op.compare(users_op[4]) == 0)
+    else if(op == users_op[4])
       usr.only_passive = atoi(arg.c_str());
-    else if(op.compare(users_op[5]) == 0)
+    else if(op == users_op[5])
       usr.user_limit = atoi(arg.c_str());
+#ifdef USE_TLS
+    else if(op == users_op[6])
+    {
+      if(arg == "allow")
+        usr.encryption = ALLOW;
+      else if(arg == "deny")
+        usr.encryption = DENY;
+      else if(arg == "force")
+        usr.encryption = FORCE;
+    }
+#endif // USE_TLS
     delete st;
   }
   delete var;
   
-  cout << "configuration for: " << usr.id << " sim_data=" << usr.sim_data << " idle=" << usr.idle << " noftp=" << usr.noftp << " only_home=" << usr.only_home << " only_passive=" << usr.only_passive << " user_limit=" << usr.user_limit << endl;
+  string for_logging =
+     "user conf for: " + usr.id
+     + " sim_data=" + util.itos(usr.sim_data)
+     + " idle=" + util.itos(usr.idle)
+     + " noftp=" + util.itos(usr.noftp)
+     + " only_home=" + util.itos(usr.only_home)
+     + " only_passive=" + util.itos(usr.only_passive)
+     + " user_limit=" + util.itos(usr.user_limit)
+#ifdef USE_TLS
+     + " encryption=";
+  if(usr.encryption == ALLOW)
+    for_logging += "allow";
+  else if(usr.encryption == DENY)
+    for_logging += "deny";
+  else if(usr.encryption == FORCE)
+    for_logging += "force"
+#endif // USE_TLS
+     ;
+  logging->log_this(3, TYPE_INFO, for_logging);
+
+  return(usr);
 }
 
 struct users_stru &Configuration::get_user(string name)
 {
-  for(int i = 0; i < num_users; i++)
-    if(users[i].id == name && name != "")
-      return users[i];
+  for(vector<users_stru>::iterator use_it = users.begin();
+      use_it != users.end(); use_it++)
+    if((*use_it).id == name && name != "")
+      return(*use_it);
   return general_user;
 }
 
-int Configuration::count_users(string *&buff, int rows, string &users)
+int Configuration::count_users(vector<string> buff, string &users)
 {
   int ant = 0;
   int deep = 1, curr_deep = 0;
   string name = "user", section = "";
-  for(int i = 0; i < rows; i++)
+  for(vector<string>::iterator buff_it = buff.begin(); buff_it != buff.end(); buff_it++)
   {
-    if(buff[i][0] == '#' || buff[i][0] == '\0')
-      continue;
-    if(strcmp(buff[i].c_str(), "{") == 0)
+    if(*buff_it == "{")
     {
-      if(curr_deep == deep && section.compare(name) == 0)
+      if(curr_deep == deep && section == name)
       {
         ant++;
-        users += buff[i-1] + ",";
+        users += *(buff_it - 1) + ",";
       }
       curr_deep++;
       if(curr_deep == deep) 
-        section = buff[i-1];
+        section = *(buff_it - 1);
     }
-    else if(strcmp(buff[i].c_str(), "}") == 0)
+    else if(*buff_it == "}")
     {
-      if(curr_deep == deep && section.compare(name) == 0)
+      if(curr_deep == deep && section == name)
         return ant;
       curr_deep--;
     }
@@ -157,10 +194,10 @@ int Configuration::count_users(string *&
   return ant;
 }
 
-void Configuration::set_general(struct general_stru &gen, string &variables)
+bool Configuration::set_general(string variables)
 {
   class StringTokenizer *var = new StringTokenizer(variables, "\n", false);
-  gen.id = var->nextToken();
+  general.id = var->nextToken();
   
   while(var->hasMoreTokens())
   {
@@ -168,110 +205,182 @@ void Configuration::set_general(struct g
     class StringTokenizer *st = new StringTokenizer(str, " ", false);
     string op = st->nextToken();
     string arg = st->restTokens();
-    if(op.compare(general_op[0]) == 0)
-      gen.connection_limit = atoi(arg.c_str());
-    else if(op.compare(general_op[1]) == 0)
-      gen.port = atoi(arg.c_str());
-    else if(op.compare(general_op[2]) == 0)
-      gen.default_type = atoi(arg.c_str());
-    else if(op.compare(general_op[3]) == 0)
-      gen.no_daemon = atoi(arg.c_str());
-    else if(op.compare(general_op[4]) == 0)
-      gen.verbose = atoi(arg.c_str());
-    else if(op.compare(general_op[5]) == 0)
-      gen.log_level = atoi(arg.c_str());
-    else if(op.compare(general_op[6]) == 0)
-      gen.xferlog = atoi(arg.c_str());
-    else if(op.compare(general_op[7]) == 0)
-      gen.admin_email = arg.c_str();
-    else if(op.compare(general_op[8]) == 0)
-      gen.welcome_msg = arg.c_str();
-    else if(op.compare(general_op[9]) == 0)
-      gen.xferlog_file = arg.c_str();
+    if(op == general_op[0])
+      general.connection_limit = atoi(arg.c_str());
+    else if(op == general_op[1])
+      general.port = atoi(arg.c_str());
+    else if(op == general_op[2])
+      general.default_type = atoi(arg.c_str());
+    else if(op == general_op[3])
+      general.no_daemon = atoi(arg.c_str());
+    else if(op == general_op[4])
+      general.verbose = atoi(arg.c_str());
+    else if(op == general_op[5])
+      general.admin_email = arg;
+    else if(op == general_op[6])
+      general.welcome_msg = arg;
+    else if(op == general_op[7])
+      general.lifebeat_tick = atoi(arg.c_str());
+    else if(op == general_op[8])
+    {
+      struct passwd *pwd = getpwnam(arg.c_str());
+      if(pwd == NULL)
+        general.user = 0;
+      else
+        general.user = pwd->pw_uid;
+    }
 #ifdef USE_TLS
-    else if(op.compare(general_op[10]) == 0)
-      gen.tls_key = arg.c_str();
-    else if(op.compare(general_op[11]) == 0)
-      gen.tls_cert = arg.c_str();
-    else if(op.compare(general_op[12]) == 0)
-      gen.tls_ca = arg.c_str();
-    else if(op.compare(general_op[13]) == 0)
-      gen.tls_crl = arg.c_str();
+    else if(op == general_op[9])
+      general.tls_key = arg;
+    else if(op == general_op[10])
+      general.tls_cert = arg;
+    else if(op == general_op[11])
+      general.tls_ca = arg;
+    else if(op == general_op[12])
+      general.tls_crl = arg;
+    else if(op == general_op[13])
+      general.dh_regenerate = atoi(arg.c_str());
 #endif
     delete st;
   }
   delete var;
+
+  string for_logging =
+    "general configuration: \
+    connection_limit=" + util.itos(general.connection_limit)
+    + " port=" + util.itos(general.port)
+    + " default_type=" + util.itos(general.default_type)
+    + " verbose=" + util.itos(general.verbose)
+    + " no_daemon=" + util.itos(general.no_daemon)
+    + " os=" + general.os
+    + " admin_email=" + general.admin_email
+    + " welcome_msg=" + general.welcome_msg
+    + " lifebeat_tick=" + util.itos(general.lifebeat_tick)
+    + " user=" + util.itos(general.user)
+#ifdef USE_TLS
+    + " tls_key=" + general.tls_key
+    + " tls_cert=" + general.tls_cert
+    + " tls_ca=" + general.tls_ca
+    + " tls_crl=" + general.tls_crl
+    + " dh_regenerate=" + util.itos(general.dh_regenerate)
+#endif // USE_TLS
+    ;
+  logging->log_this(3, TYPE_INFO, for_logging);
+
+  return(true);
 }
 
-void Configuration::get_variables(string *&buff, int rows, string &str, const char *key, int deep)
+bool Configuration::set_logger(string variables)
 {
-  int curr_deep = 0;
-  string section = "";
-  for(int i = 0; i < rows; i++)
+  class StringTokenizer *var = new StringTokenizer(variables, "\n", false);
+
+  while(var->hasMoreTokens())
   {
-    if(buff[i][0] == '#' || buff[i][0] == '\0')
-      continue;
-    if(strcmp(buff[i].c_str(), "{") == 0)
+    string str = var->nextToken();
+    class StringTokenizer *st = new StringTokenizer(str, " ", false);
+    string op = st->nextToken();
+    string arg = st->restTokens();
+    if(op == log_op[0])
+      logger.log_level = atoi(arg.c_str());
+    else if(op == log_op[1])
     {
-      section = buff[i-1];
-      curr_deep++;
-      if(curr_deep == deep)
-        str = section + "\n";
+      if(!(atoi(arg.c_str())))
+        logger.xferlog = false;
     }
-    else if(strcmp(buff[i].c_str(), "}") == 0)
+
+    else if(op == log_op[2])
+      logger.xferlog_file = arg;
+
+    else if(op == log_op[3])
     {
-      if(curr_deep == deep && section == key)
-        return;
-      curr_deep--;
+      if(arg != "syslog")
+        logger.authlog = arg;
     }
-    else if(curr_deep == deep && section == key && buff[i+1][0] != '{')
+
+    else if(op == log_op[4])
     {
-      str += buff[i] + "\n";
+      if(arg != "syslog")
+        logger.infolog = arg;
     }
-  }
-}
 
-void Configuration::fill_buff(string *&buff, string &filename, int rows)
-{
-  ifstream fin;
-  fin.open(filename.c_str(), ios::in);
+    else if(op == log_op[5])
+    {
+      if(arg != "syslog")
+        logger.debuglog = arg;
+    }
   
-  for(int i = 0; !fin.eof() && i < rows; i++)
+    else if(op == log_op[6])
   {
-    char *buffer = new char[251];
-    memset(buffer, '\0', 251);
-    fin.getline(buffer, 250);
-    trim(buffer);
-    buff[i] = string(buffer);
-    delete[] buffer;
+      if((atoi(arg.c_str())))
+        logger.thread_id = true;
   }
 
-  fin.close();
+    delete st;
+  }
+  delete var;
+
+  string for_logging =
+    "logging configuration: \
+    log_level=" + util.itos(logger.log_level)
+    + " xferlog_enable=" + util.itos(logger.xferlog)
+    + " xferlog_file=" + logger.xferlog_file + " "
+    + log_op[3] + (logger.authlog.empty() ?
+        "=syslog " : "=" + logger.authlog + " ")
+    + log_op[4] + (logger.infolog.empty() ?
+        "=syslog " : "=" + logger.infolog + " ")
+    + log_op[5] + (logger.debuglog.empty() ?
+        "=syslog " : "=" + logger.debuglog)
+    + " thread_id=" + util.itos(logger.thread_id)
+    ;
+  logging->log_this(3, TYPE_INFO, for_logging);
+
+  return(true);
 }
 
-int Configuration::file_rows(string &filename)
+string Configuration::get_variables(vector<string> &buff, const char *key, int deep)
 {
-  ifstream fin;
-  fin.open(filename.c_str(), ios::in);
-  int rows = 0;
-  while(!fin.eof())
+  int curr_deep = 0;
+  string section, str;
+  for(vector<string>::iterator buff_it = buff.begin(); buff_it != buff.end(); buff_it++)
+  {
+    if((*buff_it).empty())
+      continue;
+    size_t comment = (*buff_it).find_first_of('#');
+    if(comment != string::npos)
+      (*buff_it).erase(comment);
+    if(*buff_it == "{")
   {
-    if(fin.get() == '\n')
-      rows++;
+      section = *(buff_it - 1);
+      curr_deep++;
+      if(curr_deep == deep)
+        str = section + "\n";
   }
-  fin.close();
-  return rows;
+    else if(*buff_it == "}")
+    {
+      if(curr_deep == deep && section == key)
+        break;
+      curr_deep--;
+    }
+    else if(curr_deep == deep && section == key && *(buff_it + 1) != "{")
+      str += *buff_it + "\n";
+  }
+  return(str);
 }
 
-void Configuration::trim(char *str)
+void Configuration::fill_buff(vector<string> &buff, string filename)
 {
-    while(str[0] == ' ')
-    {
-      for(unsigned int i = 0; i < strlen(str); i++)
-        str[i] = str[i+1];
-    }
-    while(str[strlen(str)-1] == ' ')
+  ifstream fin;
+  fin.open(filename.c_str(), ifstream::in);
+
+  while(fin.good())
     {
-      str[strlen(str)-1] = '\0';
+    string buffer;
+    getline(fin, buffer);
+    util.clean_string(buffer);
+    if(!fin.good() || buffer.empty())
+      continue;
+    buff.push_back(buffer);
     }
+
+  fin.close();
 }
Index: Configuration.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Configuration.h,v
retrieving revision 1.21
retrieving revision 1.33
diff -u -p -b -r1.21 -r1.33
--- Configuration.h	10 Jul 2004 14:14:45 -0000	1.21
+++ Configuration.h	22 Jan 2005 23:06:05 -0000	1.33
@@ -1,11 +1,35 @@
+/////////////////////////////////////////////////////////////////////
+//  $Id: Configuration.h,v 1.33 2005/01/22 23:06:05 klas Exp $
+//
+//  Usage: Configure class, reading the config file and holding
+//           configurish variables.
+//
+//  A part of babyftpd, licensed under the GNU GPL, see the file                
+//    LICENSE for complete information.                                         
+/////////////////////////////////////////////////////////////////////
+
+
 #ifndef __CONFIGURATION_H__
 #define __CONFIGURATION_H__
 
 #ifdef __CONFIGURATION_CPP__
 #include "generic.h"
 #include "StringTokenizer.h"
+#include "Utilities.h"
+#include "Log.h"
 #endif
 
+struct log_stru
+{
+  int log_level;
+  bool xferlog;
+  string xferlog_file;
+  string authlog;
+  string infolog;
+  string debuglog;
+  bool thread_id;
+};
+
 struct users_stru
 {
   string id;    
@@ -15,6 +39,9 @@ struct users_stru
   int only_home;
   int only_passive;
   int user_limit;
+#ifdef USE_TLS
+  int encryption;
+#endif // USE_TLS
 };
 
 struct general_stru
@@ -24,48 +51,48 @@ struct general_stru
   int port; 
   int default_type;
   int verbose;
-  int log_level;
-  int xferlog;
   bool no_daemon;
   string os;
   string admin_email;
   string welcome_msg;
-  string xferlog_file;
+  int lifebeat_tick;
+  uid_t user;
 #ifdef USE_TLS  
   string tls_key;
   string tls_cert;
   string tls_ca;
   string tls_crl;
+  int dh_regenerate;
 #endif
 };
 
 class Configuration
 {
   private:
-    struct users_stru *users;
+    vector<users_stru> users;
     int num_users;
     bool parsed;
-    int count_users(string *&buff, int rows, string &users);
-    int file_rows(string &filename);
-    void fill_buff(string *&buff, string & filename, int rows);
-    void get_variables(string *&buff, int rows, string &str, const char *key, int deep = 1);
-    void set_general(struct general_stru &gen, string &variables);
-    void set_users(struct users_stru &usr, string &variables);
-    void trim(char *str);
+    int count_users(vector<string>, string&);
+    void fill_buff(vector<string>&, string);
+    string get_variables(vector<string>&, const char*, int);
+    bool set_general(string variables);
+    struct users_stru set_users(string);
+    bool set_logger(string variables);
   public:
     bool parse_config_file();
     string conf_file;
+    struct log_stru logger;
     struct general_stru general;
     struct users_stru general_user;
     Configuration(void);
-    struct users_stru &get_user(string name);
+    struct users_stru &get_user(string);
     ~Configuration(void);
 };
 
 #ifdef USE_TLS
 const string general_op[14] = 
 #else
-const string general_op[10] =
+const string general_op[9] =
 #endif // USE_TLS
 {
   "connection_limit",
@@ -73,20 +100,35 @@ const string general_op[10] =
   "default:type", 
   "no_daemon", 
   "verbose", 
-  "log_level", 
-  "xferlog", 
   "admin_email", 
   "welcome_msg",
-  "xferlog_file"
+  "lifebeat_tick",
+  "user"
 #ifdef USE_TLS
   ,"tls_key",
   "tls_cert",
   "tls_ca",
-  "tls_crl"
+  "tls_crl",
+  "dh_regenerate"
 #endif
 };
 
+const string log_op[7] =
+{
+  "log_level",
+  "xferlog",
+  "xferlog_file",
+  "authlog",
+  "infolog",
+  "debuglog",
+  "thread_id"
+};
+
+#ifdef USE_TLS
+const string users_op[7] =
+#else
 const string users_op[6] =
+#endif // USE_TLS
 {
   "sim_data", 
   "idle",
@@ -94,6 +136,16 @@ const string users_op[6] =
   "only_home",
   "only_passive",
   "user_limit"
+#ifdef USE_TLS
+  ,"encryption"
+#endif // USE_TLS
 };
 
+extern class Utilities util;
+
+#ifdef USE_TLS
+#define ALLOW 1
+#define FORCE 2
+#define DENY 3
+#endif // USE_TLS
 #endif
Index: Handler.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Handler.cpp,v
retrieving revision 1.118
retrieving revision 1.143
diff -u -p -b -r1.118 -r1.143
--- Handler.cpp	10 Jul 2004 14:14:45 -0000	1.118
+++ Handler.cpp	22 Jan 2005 17:18:51 -0000	1.143
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: Handler.cpp
+// $Id: Handler.cpp,v 1.143 2005/01/22 17:18:51 klas Exp $
+//
 // Usage: the main loop for connected clients and interpreter for
 //        ftp commands.
 //
@@ -14,7 +15,7 @@
 
 struct command_info Handler::cmd_info[] = {
   { "SYST",  0, &Commands::sim1, COM_SYST,  HLP_SYST }, //0
-  { "HELP", -1, &Commands::help, 0,         HLP_HELP },
+  { "HELP", -1, &Commands::help, BEFORE_USER, HLP_HELP },
   { "RETR", -1, &Commands::retr, 0,         HLP_RETR },
   { "STOR", -1, &Commands::stor, COM_STOR,  HLP_STOR },
   { "PORT",  1, &Commands::port, COM_PORT,  HLP_PORT },
@@ -22,8 +23,8 @@ struct command_info Handler::cmd_info[] 
   { "PASV",  0, &Commands::pasv, COM_PASV,  HLP_PASV },
   { "EPSV", -1, &Commands::pasv, COM_EPSV,  HLP_EPSV },
   { "PWD",   0, &Commands::sim1, COM_PWD,   HLP_PWD  },
-  { "CWD",  -1, &Commands::cwd,  0,         HLP_CWD  },
-  { "CDUP",  0, &Commands::sim1, COM_CDUP,  HLP_CDUP }, //10
+  { "CWD",  -1, &Commands::cwd,  COM_CWD,   HLP_CWD  },
+  { "CDUP",  0, &Commands::cwd,  COM_CDUP,  HLP_CDUP }, //10
   { "MKD",  -1, &Commands::mkd,  0,         HLP_MKD  },
   { "RMD",  -1, &Commands::rmd,  0,         HLP_RMD  },
   { "DELE", -1, &Commands::dele, 0,         HLP_DELE },
@@ -33,87 +34,77 @@ struct command_info Handler::cmd_info[] 
   { "MODE",  1, &Commands::sim1, COM_MODE,  HLP_MODE },
   { "STRU",  1, &Commands::sim1, COM_STRU,  HLP_STRU },
   { "SIZE", -1, &Commands::sim2, COM_SIZE,  HLP_SIZE },
-  { "USER",  1, &Commands::user, 0,         HLP_USER }, //20
-  { "PASS",  1, &Commands::pass, 0,         HLP_PASS },
-  { "QUIT", -1, &Commands::quit, 0,         HLP_QUIT },
+  { "USER",  1, &Commands::user, BEFORE_USER, HLP_USER }, //20
+  { "PASS",  1, &Commands::pass, BEFORE_USER, HLP_PASS },
+  { "QUIT", -1, &Commands::quit, BEFORE_USER, HLP_QUIT },
   { "NOOP",  0, &Commands::sim1, COM_NOOP,  HLP_NOOP },
   { "MDTM", -1, &Commands::sim2, COM_MDTM,  HLP_MDTM },
-  { "FEAT",  0, &Commands::sim1, COM_FEAT,  HLP_FEAT }, //25
+  { "FEAT",  0, &Commands::sim1, COM_FEAT | BEFORE_USER, HLP_FEAT }, //25
   { "RNFR", -1, &Commands::rname, COM_FROM, HLP_RNFR },
   { "RNTO", -1, &Commands::rname, COM_TO,   HLP_RNTO },
   { "MLST", -1, &Commands::sim2, COM_MLST,  HLP_MLST },
   { "MLSD", -1, &Commands::list, COM_MLSD,  HLP_MLSD },
-  { "APPE", -1, &Commands::stor, COM_APPE,  HLP_APPE },
-  { "OPTS", -1, &Commands::opts, 0,         HLP_OPTS }, //30
+  { "APPE", -1, &Commands::stor, COM_APPE,  HLP_APPE }, //30
+  { "OPTS", -1, &Commands::opts, 0,         HLP_OPTS },
   { "REST",  1, &Commands::rest, 0,         HLP_REST },
-  { "ABOR",  0, &Commands::abor, 0,         NULL     }, //NULL means no help.
-  { "XCWD", -1, &Commands::cwd,  0,         cmd_info[9].hlp_info }, // as of rfc 1123
-  { "XPWD",  0, &Commands::sim1, COM_PWD,   cmd_info[8].hlp_info },
-  { "XCUP",  0, &Commands::sim1, COM_CDUP,  cmd_info[10].hlp_info }, //35
-  { "XMKD", -1, &Commands::mkd,  0,         cmd_info[11].hlp_info },
-  { "XRMD", -1, &Commands::rmd,  0,         cmd_info[12].hlp_info },
+  { "XCWD", -1, &Commands::cwd,  COM_CWD,   HLP_CWD  }, // as of rfc 1123
+  { "XPWD",  0, &Commands::sim1, COM_PWD,   HLP_PWD  },
+  { "XCUP",  0, &Commands::sim1, COM_CDUP,  HLP_CDUP }, //35
+  { "XMKD", -1, &Commands::mkd,  0,         HLP_MKD  },
+  { "XRMD", -1, &Commands::rmd,  0,         HLP_RMD  },
 #ifdef USE_TLS
-  { "AUTH", 1,  &Commands::auth, 0,         HLP_AUTH },
-  { "PBSZ", 1,  &Commands::sim1, COM_PBSZ,  HLP_PBSZ },
-  { "PROT", 1,  &Commands::sim1, COM_PROT,  HLP_PROT }, //40
+  { "AUTH",  1, &Commands::auth, BEFORE_USER, HLP_AUTH },
+  { "PBSZ",  1, &Commands::sim1, COM_PBSZ | BEFORE_USER, HLP_PBSZ },
+  { "PROT",  1, &Commands::sim1, COM_PROT | BEFORE_USER, HLP_PROT }, //40
   { "CCC",  0,  &Commands::sim1, COM_CCC,   HLP_CCC },
+  // these commands are required to be understood by rfc2228, even if
+  // we don't use them.
+  { "CONF", -1, &Commands::sim1, COM_CONF | BEFORE_USER, "" },
+  { "MIC",  -1, &Commands::sim1, COM_MIC | BEFORE_USER, "" },
+  { "ENC",  -1, &Commands::sim1, COM_ENC | BEFORE_USER, "" },
 #endif // USE_TLS                
-  { "\n",    0, NULL           , 0,         NULL     } // this goes last.
+  // An empty hlp field means no help will be displayed about the 
+  // object, what is noteworthy is that those entries must come last 
+  // as to not screwup the format when we display the help list.
+  { "ABOR",  0, &Commands::abor, 0,         ""       },
+  { "\n",    0, NULL           , LAST_COM,  ""       } // this goes last.
 };
 
 class User *Handler::initializer(int socket_id)
 {
   struct sockaddr_in addr;
-  string log;
   socklen_t len = sizeof(sockaddr_in);
-  class dns_wrapper *dns_wrap = new dns_wrapper;
   
-  getpeername(socket_id, (struct sockaddr*)&addr, &len);
+  getpeername(socket_id, reinterpret_cast<struct sockaddr*>(&addr), &len);
   class User *user = new User(socket_id, addr); // initiating the user object, with initial stuff
 
-  log = "new connection from: ";
-  log.append(inet_ntoa(addr.sin_addr));
-  pthread_mutex_lock(&sys_log_lock);
-  syslog(LOG_DEBUG, log.c_str());
-  pthread_mutex_unlock(&sys_log_lock);
+  string log = "new connection from: ";
+  log += inet_ntoa(addr.sin_addr);
+  logging->log_this(3, TYPE_INFO, log);
 
-  pthread_mutex_lock(&user_list_mutex);
+  sem_wait(&user_list_lock);
   user_list.push_back(user);
-  pthread_mutex_unlock(&user_list_mutex);
+  sem_post(&user_list_lock);
   
-  if((int)user_list.size() > config->general.connection_limit)
+  string message;
+  if(static_cast<int>(user_list.size()) > config->general.connection_limit)
   {
     // reached maximum number of connections...
-    comm.ftp_send(user, "421 Maximum number of connections reached, please try again later.");
-    pthread_mutex_lock(&user->lock);
-    close(user->socket_id);
+    message = "421 Maximum number of connections reached, please try again later.";
+    sem_wait(&user->user_lock);
     user->logged_in = LOGGED_OUT;
-    pthread_mutex_unlock(&user->lock);
+    sem_post(&user->user_lock);
   }
+  else
+  {
+    // dns lookup should go here.. find a nice way of doing it.
+    message = "220 " + config->general.welcome_msg;
+  }
+  comm.ftp_send(user, message);
   
-  dns_wrap->addr = user->ctrl_addr;
-  dns_wrap->host_name = &user->host_name;
-  pthread_mutex_lock(&user->lock);
-  pthread_create(&user->dns_thread, NULL, dns_lookup, (void*)dns_wrap);
-  pthread_detach(user->dns_thread);
-  pthread_mutex_unlock(&user->lock);
-  comm.ftp_send(user, "220 " + config->general.welcome_msg);
   return(user);
 }
 
-void *dns_lookup(void *dns_wrap)
-{
-  struct hostent *host_struct;
-  int ip = inet_addr(inet_ntoa(((class dns_wrapper*)dns_wrap)->addr.sin_addr));
-  host_struct = gethostbyaddr((char*)&ip, sizeof(ip), AF_INET);
-  if(host_struct)
-    *((class dns_wrapper*)dns_wrap)->host_name = host_struct->h_name;
-
-  cout << *((class dns_wrapper*)dns_wrap)->host_name << endl;
-  delete (class dns_wrapper*)dns_wrap;
-  return(NULL);
-}
-
 bool Handler::init(User *user)
 {
   while(true)
@@ -129,49 +120,60 @@ bool Handler::init(User *user)
 
 bool Handler::interpreter(User *user, string command)
 {
-  string argument;
-  int words, cmd;
+  string argument, message;
+  int cmd = 0;
+  class StringTokenizer *st = NULL;
+
+  int words = util.clean_string(command);
 
-  if((words = util.clean_string(command)) > 0)
+  if(words > 0)
   {
-    class StringTokenizer *st = new StringTokenizer(command, " ", true);
+    st = new StringTokenizer(command, " ", true);
     command = st->nextToken();
+  }
+
+  transform(command.begin(), command.end(), command.begin(), (int(*)(int))toupper);
+  if(st)
+  {
+    if(command == "SITE")
+    {
+      st->nextToken();
+      command += " " + st->nextToken();
+      transform(command.begin() + 4, command.end(), command.begin() + 4, (int(*)(int))toupper);
+    }
     argument = st->restTokens();
-    delete st;
+    delete(st);
   }
-  util.upper(command);
+
   if(command != "PASS")
-    cout << command << "-" << argument << endl;
+    logging->log_this(5, TYPE_DEBUG, command + "-" + argument);
   else
-    cout << "PASS-********" << endl;
+    logging->log_this(5, TYPE_DEBUG, "PASS-**********");
   
-  for(cmd = 0; cmd_info[cmd].command != "\n"; cmd++)
+  for(; cmd_info[cmd].extra_flag != LAST_COM; cmd++)
     if(cmd_info[cmd].command == command)
       break;
     
-  if(cmd_info[cmd].command == "\n")
-    comm.ftp_send(user, "500 '" + command + "' not understood.");
+  if(cmd_info[cmd].extra_flag == LAST_COM)
+    message = "500 '" + command + "' not understood.";
+  else
+  {
+    if(user->logged_in < LOGGED_IN && !util.is_set(cmd_info[cmd].extra_flag, BEFORE_USER))
+      message = "530 Login with 'USER' and 'PASS' first.";
   else
   {
     if((user->temp_buf.size() > 0) && command != "RNTO")
       user->temp_buf.erase(); // we don't want this hanging around forever.
 
-    if(user->logged_in < LOGGED_IN && command != "USER" && command != "HELP" && command != "PASS" && command != "QUIT" && command != "FEAT" && command != "AUTH" && command != "PROT" && command != "PBSZ")
-      comm.ftp_send(user, "530 Login with 'USER' and 'PASS' first.");
-    else
-    {
       if(words == 0 && words < cmd_info[cmd].ant_arg)
-        comm.ftp_send(user, "501 '" + command + "': requires an argument.");
+        message = "501 '" + command + "': requires an argument.";
       else if(cmd_info[cmd].ant_arg != -1 && words > cmd_info[cmd].ant_arg)
-        comm.ftp_send(user, "501 '" + command + "': to many arguments to command.");
+        message = "501 '" + command + "': to many arguments to command.";
       else
-      {
-        if(cmd_info[cmd].extra_flag > 0)
-          argument.insert(argument.begin(), cmd_info[cmd].extra_flag);
-        bool (Commands::*pf)(User*, string) = cmd_info[cmd].pf;
-        (comm.*pf)(user, argument);
-      }
+        ((comm.*cmd_info[cmd].pf) (user, argument, cmd_info[cmd].extra_flag));
     }
   }
+  if(message.size() > 0)
+    comm.ftp_send(user, message);
   return(true);
 }
